<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>CSS and Bootstrap Flex</title>
  <!-- links -->
  <!-- <link rel="stylesheet" href="./index.css"> -->
  <!-- <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-GLhlTQ8iRABdZLl6O3oVMWSktQOp6b7In1Zl3/Jr59b6EGGoI1aFkw7cmDA6j6gD" crossorigin="anonymous"> -->
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css" integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
</head>
<body>
  <div class="text-center">
    <h1>Bootstrap Flex</h1>
    <p>Use the d-flex class to create a flex container and transform direct into flex items</p>
    
    <h2>Centering elements</h2>
    <div style="height: 500px;" 
    class="
    bg-secondary p-3 d-flex 
    justify-content-center 
    align-items-center 
    flex-column
    ">
      <div class="h-25 p-3 bg-success ">Flex Item A</div>
      <div class="h-25 p-3 bg-warning">Flex Item B</div>
      <div class="h-25 p-3 bg-danger">Flex Item C</div>
    </div>

    <h2>Flex Row</h2>
    <div class="bg-dark p-3 d-flex flex-row">
      <div class="p-3 bg-success">Flex Item A</div>
      <div class="p-3 bg-warning">Flex Item B</div>
      <div class="p-3 bg-danger">Flex Item C</div>
    </div>

    <h3>Flex Row Reverse</h3>
    <div class="bg-dark p-3 d-flex flex-row-reverse">
      <div class="p-3 bg-success">Flex Item A</div>
      <div class="p-3 bg-warning">Flex Item B</div>
      <div class="p-3 bg-danger">Flex Item C</div>
    </div>

    <h2>Creating space between elements</h2>
    <div class="bg-dark p-3 d-md-flex justify-content-around">
      <div class="p-3 bg-success col-md-2">Card A</div>
      <div class="p-3 bg-warning col-md-2">Card B</div>
      <div class="p-3 bg-danger col-md-2">Card C</div>
    </div>

    <h2>Flexbox with margin</h2>
    <div class="bg-dark p-3 d-flex">
      <div class="p-3 bg-success me-auto">Flex Item A</div>
      <div class="p-3 bg-warning">Flex Item B</div>
      <div class="p-3 bg-danger">Flex Item C</div>
      <div class="p-3 bg-primary">Flex Item D</div>
    </div>

    <h2>Nested flex elements</h2>
    <div class="bg-dark p-3 d-block d-md-flex">
      <div class="p-3 bg-success mr-auto">Flex Item A</div>
      <div class="w-50 d-block d-md-flex justify-content-between">
        <div class="p-3 bg-warning">Flex Item B</div>
        <div class="p-3 bg-danger">Flex Item C</div>
        <div class="p-3 bg-primary">Flex Item D</div>
      </div>
    </div>

    <style>
      .img-200px {
        width: 200px;
        height: 200px;
      }
    </style>

    <h2>Sampel Images in Flex</h2>
    <div class="d-md-flex justify-content-around">
      <img class="img-200px order-sm-1" src="https://assets.pokemon.com/assets/cms2/img/pokedex/full/143.png" alt="">
      <img class="img-200px order-sm-3" src="https://pm1.narvii.com/6429/a51292b3723d285edd89a7c2e6e2cc9e0ce57398_hq.jpg" alt="">
      <img class="img-200px order-sm-0" src="https://encrypted-tbn0.gstatic.com/images?q=tbn:ANd9GcS13yH3S1cvJviPNZKUlwtX5teAGS4CVRqOXw&usqp=CAU" alt="">
    </div>

  </div>
</body>
</html>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js" integrity="sha384-w76AqPfDkMBDXo30jS1Sgez6pr3x5MlQ1ZAGC+nuZB+EYdgRZgiwxhTBTkF7CXvN" crossorigin="anonymous"></script>

<!-- 
				Note: 
					- The "flex" value of the "display" property will change the element into a block-level flex container.
					- This will make all the child elements become "flexible" that allows them to occupy space enough for the content of an element and at the same time will have the elements appear beside each other.
					- The "d-flex" class will change all the child div elements into flex items.
					- The flex items will only occupy space enough for the element's content allowing is more flexibility to manipulate our elements.
          "justiify-content"
          - The CSS "justify-content" property allows us to manipulate the positioning of elements horizontally.
					- The CSS "justify-content" property may only be applied if the element has a "flex" value for it's "display" property.
					- The "justify-content-center" class will horizontally center all child elements.
					- There may be instances that justify-content property may not work due to a lack of width on it's parent element.
          "align items"
          - The CSS "align-items" property allows us to manipulate the positioning of elements vertically.
					- The CSS "align-items" property may only be applied if the element has a "flex" value for it's "display" property.
					- The "align-items-center" class will vertically center all child elements.
					- There may be instances that align-items property may not work due to a lack of height on it's parent element.
				- The "flex-row" and "flex-row-reverse" classes may only be applied if the element has a "flex" value for it's "display" property.
				- The CSS "flex-row" and "flex-row-reverse" classes changes how the elements are displayed horizontally.

        - The "d-md-flex" class will apply a "flex" value to the "display" property on a "medium" sized screen and larger.
				- On smaller screens flex will not be applied to the parent element making it so elements will stack on top of each other.
				- The "col-md-2" will change the width of the child elements to occupy 2 out of 12 columns of it's parent container on medium screens and larger but will occupy the full width on mobile phones.
        - This approach is good for displaying elements side by side on tablets and larger screents but stacked on top of each other on small screens.
				- The "justify-content-around" class may only be applied if the element has a "flex" value for it's "display" property.
				- The "justify-content-around" class centers elements horizontally while creating space between elements and the borders of it's parent container. 
			Important Note:
				- The "mr-auto" class will occupy the remaining width of it's parent container pushing all other elements inline.
        Important Note:
				- The "d-" classes only applies to it's child elements and not to it's grandchild elements.
				- This is the reason why multiple "d-flex" classes are needed in order to align elements in nested div tags.
				- The combination of "d-block" and "d-md-flex" allows for elements to appear side by side on medium and larger screens and appear on top of each other on smaller screens.
        - The "d-block" class changes the "display" property of the "div" tag back to it's original "block" value.
				- The combination of the "w-50" and "justify-content-between" allows to create space between the flex items.
				- Unlike the "justify-content-around", the "justify-content-between" creates space between elements but removes the padding leftmost and rightmost padding of it's parent element.
-->